﻿local mwc_ui = UI.CreateContext("UI")
local mwc_background = UI.CreateFrame("SimpleWindow","Background",mwc_ui)
local mwc_select = UI.CreateFrame("SimpleSelect","Selecting Dropdown Box",mwc_ui)
local mwc_wfcount = UI.CreateFrame("Text","Number of Warfront",mwc_ui)
local mwc_totalcall = UI.CreateFrame("Text","Number of Calling",mwc_ui)
local mwc_percall = UI.CreateFrame("Text","Percent of Calling",mwc_ui)
local mwc_roleNum = {}
local mwc_rolePerc = {}
local mwc_overallPerc = {}
local mwc_roleText = {}

function MontsWarfrontCounter.Build()
	MontsWarfrontCounter.BuildWindow(false)
	MontsWarfrontCounter.CreateTextFrames()
	MontsWarfrontCounter.BuildTextFrames(false)
	MontsWarfrontCounter.BuildSelect(false)
end

function MontsWarfrontCounter.BuildWindow(show)
	mwc_background:SetVisible(show)
	mwc_background:SetCloseButtonVisible(show)
	mwc_background:SetTitle("Mont's Warfront Counter")
	mwc_background:SetLayer(0)
	mwc_background:SetPoint("TOPLEFT",mwc_ui,"TOPLEFT",500,100)
end

function mwc_background.Event:Close()
	mwc_background:SetVisible(false)
	mwc_select:SetVisible(false)
	mwc_select:SetItems({"","Cleric","Mage","Rogue","Warrior"})
	for i=1,4,1 do
		mwc_roleText[i]:SetVisible(false)
		mwc_roleNum[i]:SetVisible(false)
		mwc_rolePerc[i]:SetVisible(false)
		mwc_overallPerc[i]:SetVisible(false)
		mwc_wfcount:SetVisible(false)
		mwc_totalcall:SetVisible(false)
		mwc_percall:SetVisible(false)
	end
end

function MontsWarfrontCounter.BuildSelect(show)
	mwc_select:SetVisible(show)
	mwc_select:SetShowArrow(show)
	mwc_select:SetLayer(3)
	mwc_select:SetItems({"","Cleric","Mage","Rogue","Warrior"})
	mwc_select:SetFontSize(20)
	mwc_select:ResizeToFit()
	mwc_select:SetSelectedIndex(1,true)
	mwc_select:SetPoint("TOPCENTER",mwc_background,"TOPCENTER",0,50)
end

function mwc_select.Event:ItemSelect(mwc_item,mwc_temp,mwc_index)
	MontsWarfrontCounter.DisplayStats(mwc_item)
end

function MontsWarfrontCounter.CreateTextFrames()
	for i=1,4,1 do
		-- Numbers for each role this class has logged
		mwc_roleNum[i] = UI.CreateFrame("Text","Role Frames",mwc_ui)
		-- The percent of this class that has played the role
		mwc_rolePerc[i] = UI.CreateFrame("Text","Role Percent Frames",mwc_ui)
		-- How much this class has accounted for the role overall
		mwc_overallPerc[i] = UI.CreateFrame("Text","Overall Percent Frames",mwc_ui)
		-- Role Text
		mwc_roleText[i] = UI.CreateFrame("Text","Roles", mwc_ui)
	end
	
end

function MontsWarfrontCounter.BuildTextFrames(show)
	-- Setup role number textframes
	mwc_wfcount:SetVisible(show)
	mwc_wfcount:SetLayer(1)
	mwc_wfcount:SetFontSize(20)
	mwc_wfcount:SetPoint("TOPCENTER",mwc_background,"TOPCENTER",0,100)
	
	mwc_totalcall:SetVisible(show)
	mwc_totalcall:SetLayer(1)
	mwc_totalcall:SetFontSize(20)
	mwc_totalcall:SetPoint("TOPCENTER",mwc_background,"TOPCENTER",0,150)
	
	mwc_percall:SetVisible(show)
	mwc_percall:SetLayer(1)
	mwc_percall:SetFontSize(20)
	mwc_percall:SetPoint("TOPCENTER",mwc_background,"TOPCENTER",0,200)
	
	
	local mwc_starty = 300
	local mwc_step = 40
	for i=1,table.maxn(mwc_roleText),1 do
		mwc_roleText[i]:SetVisible(show)
		mwc_roleText[i]:SetLayer(1)
		mwc_roleText[i]:SetFontSize(15)
		mwc_roleText[i]:SetPoint("TOPLEFT",mwc_background,"TOPLEFT",12,mwc_starty+(mwc_step*(i-1)))
	end
	mwc_roleText[1]:SetText("Heal")
	mwc_roleText[2]:SetText("DPS")
	mwc_roleText[3]:SetText("Supp")
	mwc_roleText[4]:SetText("Tank")
	local mwc_startx = 100
	for i=1,table.maxn(mwc_roleNum),1 do
		mwc_roleNum[i]:SetVisible(show)
		mwc_roleNum[i]:SetPoint("TOPLEFT",mwc_background,"TOPLEFT",mwc_startx,mwc_starty+(mwc_step*(i-1)))
		mwc_roleNum[i]:SetFontSize(15)
		mwc_roleNum[i]:SetLayer(1)
	end
	mwc_startx = mwc_startx+100
	for i=1,table.maxn(mwc_rolePerc),1 do
		mwc_rolePerc[i]:SetVisible(show)
		mwc_rolePerc[i]:SetLayer(1)
		mwc_rolePerc[i]:SetFontSize(15)
		mwc_rolePerc[i]:SetPoint("TOPLEFT",mwc_background,"TOPLEFT",mwc_startx,mwc_starty+(mwc_step*(i-1)))
	end
	mwc_startx = mwc_startx+100
	for i=1,table.maxn(mwc_overallPerc),1 do
		mwc_overallPerc[i]:SetVisible(show)
		mwc_overallPerc[i]:SetLayer(1)
		mwc_overallPerc[i]:SetFontSize(15)
		mwc_overallPerc[i]:SetPoint("TOPLEFT",mwc_background,"TOPLEFT",mwc_startx,mwc_starty+(mwc_step*(i-1)))
	end
end

-- Order is heal, dps, support, tank
function MontsWarfrontCounter.DisplayStats(mwc_calling)
	local mwc_countstring = tostring(MWC_Stats.count)
	local mwc_everyone = MWC_Stats.cleric + MWC_Stats.mage + MWC_Stats.rogue + MWC_Stats.warr
	local mwc_total = ""
	local mwc_dpsnum = ""
	local mwc_healnum = ""
	local mwc_suppnum = ""
	local mwc_tanknum = ""
	local mwc_dpsper = ""
	local mwc_healper = ""
	local mwc_tankper = ""
	local mwc_suppper = ""
	local mwc_ovalldps = ""
	local mwc_ovallheal = ""
	local mwc_ovallsupp = ""
	local mwc_ovalltank = ""
	if mwc_calling == "Cleric" then
		mwc_total = tostring(MWC_Stats.cleric)
		mwc_dpsnum = tostring(MWC_Stats.cleric_dps)
		mwc_healnum = tostring(MWC_Stats.cleric_heal)
		mwc_suppnum = tostring(MWC_Stats.cleric_support)
		mwc_tanknum = tostring(MWC_Stats.cleric_tank)
		
		mwc_dpsper = string.sub(tostring(100*MWC_Stats.cleric_dps/MWC_Stats.cleric),1,4) .. "%"
		mwc_healper = string.sub(tostring(100*MWC_Stats.cleric_heal/MWC_Stats.cleric),1,4) .. "%"
		mwc_suppper = string.sub(tostring(100*MWC_Stats.cleric_support/MWC_Stats.cleric),1,4) .. "%"
		mwc_tankper = string.sub(tostring(100*MWC_Stats.cleric_tank/MWC_Stats.cleric),1,4) .. "%"
		
		mwc_ovalldps = string.sub(tostring(100*MWC_Stats.cleric_dps/MWC_Stats.dps),1,4) .. "%"
		mwc_ovallheal = string.sub(tostring(100*MWC_Stats.cleric_heal/MWC_Stats.heal),1,4) .. "%"
		mwc_ovallsupp = string.sub(tostring(100*MWC_Stats.cleric_support/MWC_Stats.support),1,4) .. "%"
		mwc_ovalltank = string.sub(tostring(100*MWC_Stats.cleric_tank/MWC_Stats.tank),1,4) .. "%"
	elseif mwc_calling == "Mage" then
		mwc_total = tostring(MWC_Stats.mage)
		mwc_dpsnum = tostring(MWC_Stats.mage_dps)
		mwc_healnum = tostring(MWC_Stats.mage_heal)
		mwc_suppnum = tostring(MWC_Stats.mage_support)
		mwc_tanknum = tostring(0)
		
		mwc_dpsper = string.sub(tostring(100*MWC_Stats.mage_dps/MWC_Stats.mage),1,4) .. "%"
		mwc_healper = string.sub(tostring(100*MWC_Stats.mage_heal/MWC_Stats.mage),1,4) .. "%"
		mwc_suppper = string.sub(tostring(100*MWC_Stats.mage_support/MWC_Stats.mage),1,4) .. "%"
		mwc_tankper = "0%"
		
		mwc_ovalldps = string.sub(tostring(100*MWC_Stats.mage_dps/MWC_Stats.dps),1,4) .. "%"
		mwc_ovallheal = string.sub(tostring(100*MWC_Stats.mage_heal/MWC_Stats.heal),1,4) .. "%"
		mwc_ovallsupp = string.sub(tostring(100*MWC_Stats.mage_support/MWC_Stats.support),1,4) .. "%"
		mwc_ovalltank = "0%"
	elseif mwc_calling == "Rogue" then
		mwc_total = tostring(MWC_Stats.rogue)
		mwc_dpsnum = tostring(MWC_Stats.rogue_dps)
		mwc_healnum = tostring(0)
		mwc_suppnum = tostring(MWC_Stats.rogue_support)
		mwc_tanknum = tostring(MWC_Stats.rogue_tank)
		
		mwc_dpsper = string.sub(tostring(100*MWC_Stats.rogue_dps/MWC_Stats.rogue),1,4) .. "%"
		mwc_healper = "0%"
		mwc_suppper = string.sub(tostring(100*MWC_Stats.rogue_support/MWC_Stats.rogue),1,4) .. "%"
		mwc_tankper = string.sub(tostring(100*MWC_Stats.rogue_tank/MWC_Stats.rogue),1,4) .. "%"
		
		mwc_ovalldps = string.sub(tostring(100*MWC_Stats.rogue_dps/MWC_Stats.dps),1,4) .. "%"
		mwc_ovallheal = "0%"
		mwc_ovallsupp = string.sub(tostring(100*MWC_Stats.rogue_support/MWC_Stats.support),1,4) .. "%"
		mwc_ovalltank = string.sub(tostring(100*MWC_Stats.rogue_tank/MWC_Stats.tank),1,4) .. "%"
	elseif mwc_calling == "Warrior" then
		mwc_total = tostring(MWC_Stats.warr)
		mwc_dpsnum = tostring(MWC_Stats.warr_dps)
		mwc_healnum = tostring(0)
		mwc_suppnum = tostring(MWC_Stats.warr_support)
		mwc_tanknum = tostring(MWC_Stats.warr_tank)
		
		mwc_dpsper = string.sub(tostring(100*MWC_Stats.warr_dps/MWC_Stats.warr),1,4) .. "%"
		mwc_healper = "0%"
		mwc_suppper = string.sub(tostring(100*MWC_Stats.warr_support/MWC_Stats.warr),1,4) .. "%"
		mwc_tankper = string.sub(tostring(100*MWC_Stats.warr_tank/MWC_Stats.warr),1,4) .. "%"
		
		mwc_ovalldps = string.sub(tostring(100*MWC_Stats.warr_dps/MWC_Stats.dps),1,4) .. "%"
		mwc_ovallheal = "0%"
		mwc_ovallsupp = string.sub(tostring(100*MWC_Stats.warr_support/MWC_Stats.support),1,4) .. "%"
		mwc_ovalltank = string.sub(tostring(100*MWC_Stats.warr_tank/MWC_Stats.tank),1,4) .. "%"
	end
	
	mwc_wfcount:SetText("Warfronts:  " .. mwc_countstring)
	mwc_totalcall:SetText("Total:  " .. tostring(mwc_everyone))
	local mwc_numcall = tonumber(mwc_total)
	mwc_percall:SetText("Percent:  " .. string.sub(tostring(100*mwc_numcall/mwc_everyone),1,4) .. "%")
	
	mwc_roleNum[1]:SetText(mwc_healnum)
	mwc_roleNum[2]:SetText(mwc_dpsnum)
	mwc_roleNum[3]:SetText(mwc_suppnum)
	mwc_roleNum[4]:SetText(mwc_tanknum)
	
	mwc_rolePerc[1]:SetText(mwc_healper)
	mwc_rolePerc[2]:SetText(mwc_dpsper)
	mwc_rolePerc[3]:SetText(mwc_suppper)
	mwc_rolePerc[4]:SetText(mwc_tankper)
	
	mwc_overallPerc[1]:SetText(mwc_ovallheal)
	mwc_overallPerc[2]:SetText(mwc_ovalldps)
	mwc_overallPerc[3]:SetText(mwc_ovallsupp)
	mwc_overallPerc[4]:SetText(mwc_ovalltank)
end

function MontsWarfrontCounter.Show()
	MontsWarfrontCounter.BuildWindow(true)
	MontsWarfrontCounter.BuildTextFrames(true)
	MontsWarfrontCounter.BuildSelect(true)
end